<template>
	<span v-if="code">{{ code }}</span>
	<span v-else>{{ error }}</span>
</template>


<script lang="ts" setup>
import { onMounted, ref } from 'vue';
import { useRouter } from 'vue-router';
import { TE } from '../../lib/types';
import { E, pipe, T } from '../../lib/utils';
import { clickupClient } from '../ts/apis';
import { CLICK_API_OAUTH_POPUP_NAME, notify, resolveOrAlertMessage, saveAuthToken } from '../ts/utils';
import { closePopupWindow } from '../ts/utils/windowUtil';


const router = useRouter();
const code = ref<string>();
const error = ref<string>();

onMounted(() => {
	const code = parse(router.currentRoute.value.query["code"]);
	pipe(
		clickupClient.oauthToken({
			code
		}),
		TE.mapLeft(err => err.clickError?.err || 'Authenticate failed.'),
		TE.chain(result => pipe(
			saveAuthToken("Click", result.access_token),
			T.map(success => success ? E.right("Token saved.") : E.left("Save access token failed."))
		)),
		TE.map(x => {
			notify(x, "success");
			setTimeout(() => {
				closePopupWindow(CLICK_API_OAUTH_POPUP_NAME);
			}, 500);
		}),
		TE.mapLeft(e => notify(e, "error")),
	)();
})

function parse(str: string | null | Array<string | null>): string {
	return (str && Array.isArray(str) ? str[0] : str) || '';
}

</script>